require 'test_helper'

class Superstore::AttributeMethods::PrimaryKeyTest < Superstore::TestCase
  test 'get id' do
    model = temp_object do
      key do
        "foo"
      end
    end
    record = model.new

    assert_equal 'foo', record.id
  end

  test 'set id' do
    issue = Issue.new id: 'foo'

    assert_equal 'foo', issue.id
  end

  test 'attributes' do
    issue = Issue.new(id: 'lol')

    assert_not_nil issue.attributes['id']
  end
end
